## rtpengine 8.3.0.0

=== Makefile ===
RTPENGINE_ROOT_DIR=.

include lib/lib.Makefile

.PHONY:	all distclean clean coverity

all:
	$(MAKE) -C daemon
	$(MAKE) -C recording-daemon
	$(MAKE) -C iptables-extension

.PHONY: with-kernel

with-kernel: all
	$(MAKE) -C kernel-module

distclean clean:
	$(MAKE) -C daemon clean
	$(MAKE) -C recording-daemon clean
	$(MAKE) -C iptables-extension clean
	$(MAKE) -C kernel-module clean
	$(MAKE) -C t clean
	rm -rf project.tgz cov-int

.DEFAULT:
	$(MAKE) -C daemon $@
	$(MAKE) -C recording-daemon $@
	$(MAKE) -C iptables-extension $@
	$(MAKE) -C kernel-module $@

.PHONY: check

check: all
	$(MAKE) -C t

coverity:
	cov-build --dir cov-int $(MAKE) check
	tar -czf project.tgz cov-int
	curl --form token=$(COVERITY_RTPENGINE_TOKEN) \
	  --form email=$(DEBEMAIL) \
	  --form file=@project.tgz \
	  --form version="$(RTPENGINE_VERSION)" \
	  --form description="automatic upload" \
	  https://scan.coverity.com/builds?project=$(COVERITY_RTPENGINE_PROJECT)

=== iptables-extension/Makefile ===
CC?=gcc
CFLAGS		= -O2 -Wall -Wstrict-prototypes -shared -fPIC
ifneq ($(RTPENGINE_VERSION),)
  CFLAGS	+= -DRTPENGINE_VERSION="\"$(RTPENGINE_VERSION)\""
else
  DPKG_PRSCHNGLG= $(shell which dpkg-parsechangelog 2>/dev/null)
  ifneq ($(DPKG_PRSCHNGLG),)
    CFLAGS	+= -DRTPENGINE_VERSION="\"$(shell dpkg-parsechangelog -l../debian/changelog | awk '/^Version: / {print $$2}')\""
  else
    CFLAGS	+= -DRTPENGINE_VERSION="\"undefined\""
  endif
endif

XTABLES_INSTALLED=$(shell \
  if pkg-config --exists xtables; then \
    echo 'xtables found'; \
  fi)
ifneq ($(XTABLES_INSTALLED),)
XTABLES = 1
CFLAGS  += $(shell pkg-config --cflags --libs xtables)
else
XTABLES = $(shell test -e /usr/include/xtables.h && echo 1)
endif

IPTABLES	= $(shell test -e /usr/include/iptables.h && echo 1)
IP6TABLES	= $(shell test -e /usr/include/ip6tables.h && echo 1)

WORK=0

.PHONY: all module clean install

all: module

ifeq ($(XTABLES),1)

WORK=1
module: libxt_RTPENGINE.so

libxt_RTPENGINE.so: libxt_RTPENGINE.c
	$(CC) $(CFLAGS) -o libxt_RTPENGINE.so libxt_RTPENGINE.c

else

ifeq ($(IPTABLES),1)
WORK=1
module: libipt_RTPENGINE.so
endif
ifeq ($(IP6TABLES),1)
WORK=1
module: libip6t_RTPENGINE.so
endif

libipt_RTPENGINE.so: libxt_RTPENGINE.c
	$(CC) $(CFLAGS) -D__ipt -o libipt_RTPENGINE.so libxt_RTPENGINE.c

libip6t_RTPENGINE.so: libxt_RTPENGINE.c
	$(CC) $(CFLAGS) -D__ip6t -o libip6t_RTPENGINE.so libxt_RTPENGINE.c

endif

ifeq ($(WORK),0)
module:
	@echo No iptables dev packages installed!
endif

clean:
	rm -f libxt_RTPENGINE.so libipt_RTPENGINE.so libip6t_RTPENGINE.so

install:

=== debian/changelog ===
rtpengine (8.3.0.0) bionic; urgency=medium

  * Release for ProVoice on Ubuntu 18.04 LTS

 -- root <thomas@mediaserve.nl>  Thu, 06 Feb 2020 21:02:52 +0000

rtpengine (8.3.0.0+0~mr8.3.0.0) unstable; urgency=medium

  [ Richard Fuchs ]
  * [d1e3dc0] byte-swap homer ID as required
  * [64e56d7] TT#73401 handle changes in RTP payload types
  * [1c72636] TT#73401 remove useless assertion
  * [9e05578] wrap-and-sort -ast
  * [6d22af9] TT#73900 ignore stray RTCP packets when confirming peer addresses
  * [f23aa26] TT#74050 add support for `unidirectional` flag to test script
  * [2a2e3f3] TT#74050 handle sinks with null addresses correctly
  * [5ac0756] TT#74300 run indent over cli_incoming_list_callid
  * [c3f5282] TT#74300 adapt CLI output to match log output for call stats
  * [08cdb4c] TT#74300 split intro for call-id CLI output

  [ Sebastian Damm ]
  * [8d7a77d] debian/control: add libconfig-tiny-perl dependency

  [ Daniel-Constantin Mierla ]
  * [5b0bee7] use pkg-config to detect xtables library for iptables-extension

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Mon, 27 Jan 2020 12:25:42 +0100

rtpengine (8.2.0.0+0~mr8.2.0.0) unstable; urgency=medium

  [ Michael Prokop ]
  * [7fbaf0a] TT#61954 Set debhelper compat level also for rtpengine-kernel-source package

  [ Richard Fuchs ]
  * [228d822] TT#68100 set iLBC encoder and decoder options
  * [ab77ed5] TT#64601 refuse overriding crypto params from SDES when DTLS is in use
  * [77087b9] don't try to save untagged streams to db
  * [8bdeb2d] TT#69701 fix incorrect address used for raddr/rport
  * [7a28b97] TT#69700 don't compensate for TS gaps with a 1-second delay
  * [8714914] TT#69700 reduce max allowed delay to half a second
  * [1ec8276] TT#69700 handle gaps in RTP TS correctly for mix output
  * [e0dd674] TT#71050 fix branch deletion from via-branch
  * [bc3d4f7] compile fix for glib versions < 2.30

  [ Guillem Jover ]
  * [7b77fb6] TT#51701 Switch from deprecated /var/run to /run

  [ Sipwise Jenkins Builder ]

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Mon, 25 Nov 2019 14:59:03 +0100

rtpengine (8.1.0.0+0~mr8.1.0.0) unstable; urgency=medium

  [ Richard Fuchs ]
  * [3fb5bef] TT#64301 log xmlrpc children to stderr
  * [25c84bb] TT#65000 fix kernel module compilation for 5.2 kernels
  * [ef20e02] TT#64259 split up codec handlers function
  * [fd16bf5] TT#64259 make DTMF detection switch explicit
  * [35740cd] TT#64259 add function to inject DTMF events
  * [68d909c] TT#64259 add functions to skip decoded samples and return encoder PTS
  * [49f6a88] TT#64259 add function to convert DTMF codes and chars
  * [b14f3b2] TT#64259 support injecting DTMF tones and events
  * [8ffc13d] TT#65100 properly cleanup redis async context
  * [bfc9799] TT#65100 don't start a redis notification context/thread when not in use
  * [3466700] TT#65800 fix SDES negotiation bug
  * [a6b4137] fix test suites for different implementations of base64 encoding
  * [22ea251] don't skip address family selection when zero port is present
  * [7b60ca8] ignore untagged/wildcard/unknown MLs in delete with via-branch
  * [65fb99b] TT#66650 fix some SSRC refcount leaks
  * [068bdb2] TT#65052 support adding pause after DTMF PCM
  * [3bf3982] TT#65052 support queuing up multiple DTMF events
  * [4d99ba8] add missing header
  * [6431cde] TT#64601 fix some compiler warnings

  [ Guillem Jover ]
  * [781b275] TT#65100 Fix double free for redis context on closure

  [ spchan ]
  * [290afbb] RPM packaging: detect systemd directories and package unit files
  * [c147556] EL8: mariadb-devel conflicts with mysql-devel
  * [487004f] EL7,8: no such package iptables-ipv6

  [ Denys ]
  * [3905a31] Update rtpengine.spec

  [ Sipwise Jenkins Builder ]

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Tue, 08 Oct 2019 09:12:35 +0200

rtpengine (8.0.0.0+0~mr8.0.0.0) unstable; urgency=medium

  [ Richard Fuchs ]
  * [3845a43] change localhost to 127.0.0.1 to avoid resolv problems
  * [290477d] fix unit test after 8fb603e5
  * [2397723] TT#61050 detect to-tag changes via via-branch
  * [79fb320] add missing header include
  * [3b6f098] TT#61850 normalize `address:port` log printing
  * [a2e0dd6] TT#62300 kernelise stream even if address doesn't match if possible
  * [10bd041] refuse startup when spool-dir and output-dir are the same
  * [24d67d0] fix mem allocation bug resulting in mem corruption during redis restore
  * [1653f32] don't free redis event base while being used
  * [c8338a4] TT#64050 add `G729a` as an incorrect alternative to `G729`
  * [344b3b9] TT#64300 don't attempt to transcode to an unsupported codec

  [ Huseyin Dikme ]
  * [a4af447] add missing errno include

  [ Razvan Crainea ]
  * [8fb603e] dtmf: prevent freeing json buf too early

  [ Guillem Jover ]
  * [fea0206] TT#61954 Update copyright years
  * [55faffd] TT#61954 Do not pass --no-enable and --no-start to sysvinit and systemd helpers
  * [2868fc6] TT#61954 Set debhelper compat level in Build-Depends instead of debian/compat

  [ Alex Balashov ]
  * [0a1c20a] README: Added call recording section and cautionary note about using same directory for spool dir and output / recording dir
  * [9e79a12] Updated README with link to issue #81.

  [ Sipwise Jenkins Builder ]

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Mon, 05 Aug 2019 21:00:14 +0200

rtpengine (7.5.0.0+0~mr7.5.0.0) unstable; urgency=medium

  [ Richard Fuchs ]
  * [a4cca5f] fix compilation for glib >= 2.60
  * [77e31f1] fix race condition after media player shutdown
  * [985cd44] fix possible segfault after failed port alloc w/ iptables option
  * [491865a] test case for github issue #766
  * [eb60289] TT#58659 fix incorrect escape seq in test script
  * [5acbf1e] TT#58659 always use the correct codec handler per packet
  * [b0b43ce] TT#58659 update test script for consistent seq numbers
  * [2298de7] honour a=rtcp-fb in SDP even if transport is advertised as RTP/(S)AVP


=== debian/control ===
Source: rtpengine
Section: net
Priority: optional
Maintainer: Sipwise Development Team <support@sipwise.com>
Homepage: https://www.sipwise.com/
Standards-Version: 3.9.8
Build-Depends:
 default-libmysqlclient-dev,
 gperf,
 iptables-dev (>= 1.4),
 libavcodec-dev (>= 6:10),
 libavfilter-dev (>= 6:10),
 libavformat-dev (>= 6:10),
 libavutil-dev (>= 6:10),
 libbcg729-dev <!pkg.rtpengine.nobcg729>,
 libbencode-perl,
 libcrypt-openssl-rsa-perl,
 libcrypt-rijndael-perl,
 libcurl4-openssl-dev | libcurl4-gnutls-dev,
 libdigest-crc-perl,
 libdigest-hmac-perl,
 libevent-dev (>= 2.0),
 libglib2.0-dev (>= 2.30),
 libhiredis-dev,
 libio-multiplex-perl,
 libio-socket-inet6-perl,
 libio-socket-ip-perl,
 libiptc-dev,
 libjson-glib-dev,
 libnet-interface-perl,
 libpcap0.8-dev,
 libpcre3-dev,
 libsocket6-perl,
 libspandsp-dev,
 libssl-dev (>= 1.0.1),
 libswresample-dev (>= 6:10),
 libsystemd-dev,
 libxmlrpc-core-c3-dev (>= 1.16.07),
 markdown,
 zlib1g-dev,

Package: rtpengine-daemon
Architecture: any
Recommends:
 rtpengine-recording-daemon,
 rtpengine-utils,
Suggests:
 system-tools,
Depends:
 lsb-base (>= 3.0-6),
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 mediaproxy-ng-daemon,
 rtpengine-redis1,
Replaces:
 mediaproxy-ng-daemon,
 rtpengine-redis1,
Description: proxy for RTP and media streams used in NGCP, userspace part
 This daemon handles the first stages of proxying media streams and talks to
 the kernel part of the proxy for eventual high-performance packet forwarding.

Package: rtpengine-recording-daemon
Architecture: any
Recommends:
 rtpengine-utils,
Suggests:
 system-tools,
Depends:
 lsb-base (>= 3.0-6),
 nfs-common,
 ${misc:Depends},
 ${shlibs:Depends},
Description: recording daemon for RTP and media streams
 This daemon handles the call recording (media intercept) component of rtpengine.

Package: rtpengine-iptables
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 mediaproxy-ng-iptables,
Replaces:
 mediaproxy-ng-iptables,
Description: IPtables extension module for the kernel-space NGCP media proxy
 Provides the IPtables extension needed to configure the mediaproxy rule.

Package: rtpengine
Architecture: all
Depends:
 rtpengine-daemon (>= ${source:Version}),
 rtpengine-iptables (>= ${source:Version}),
 rtpengine-kernel-dkms (>= ${source:Version}),
 rtpengine-recording-daemon (>= ${source:Version}),
 rtpengine-utils (>= ${source:Version}),
 ${misc:Depends},
Conflicts:
 mediaproxy-ng,
Replaces:
 mediaproxy-ng,
Description: NGCP RTP/media proxy - meta package
 This is a meta package for easy installation of all four parts of the NGCP
 media proxy. It will install the user-space daemon, the kernel-space IPtables
 module, the IPtables extension module and utility scripts.

Package: rtpengine-kernel-source
Architecture: all
Section: kernel
Depends:
 module-assistant,
 ${misc:Depends},
Conflicts:
 mediaproxy-ng-kernel-source,
Replaces:
 mediaproxy-ng-kernel-source,
Description: IPtables kernel module for the NGCP media proxy - source
 Provides the kernel-space part of the NGCP media proxy for high-
 performance packet forwarding.
 This package contains the source to be built with module-assistant or
 kernel-package.

Package: rtpengine-kernel-dkms
Architecture: all
Section: kernel
Suggests:
 system-tools,
Depends:
 dkms (>= 1.95),
 lsb-release,
 ${misc:Depends},
Conflicts:
 mediaproxy-ng-kernel-dkms,
Replaces:
 mediaproxy-ng-kernel-dkms,
Description: IPtables kernel module for the NGCP media proxy - DKMS
 Provides the kernel-space part of the NGCP media proxy for high-
 performance packet forwarding.
 This package contains the source to be built with dkms.

Package: rtpengine-utils
Architecture: all
Depends:
 libbencode-perl,
 libconfig-tiny-perl,
 libcrypt-rijndael-perl,
 libdigest-hmac-perl,
 libio-socket-inet6-perl,
 libio-socket-ip-perl,
 libsocket6-perl,
 netcat-openbsd | netcat,
 ${misc:Depends},
 ${perl:Depends},
Description: scripts and Perl modules for NGCP rtpengine
 This package contains scripts and Perl modules for NGCP rtpengine

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

## kernel package specific stuff
# Name of the source package
psource:=rtpengine-kernel-source
# Name of the dkms package
pdkms:=rtpengine-kernel-dkms
# short upstream name, used for module source directory
sname:=rtpengine
# Source version
sversion:=$(DEB_VERSION_UPSTREAM)

PACKAGE=rtpengine-kernel
## end of kernel package specific stuff

XTABLES_DIR:=$(shell pkg-config xtables --variable=xtlibdir || echo /lib/xtables)

%:
	dh $@

override_dh_auto_install-indep:
	# Create the directories to install the source into
	dh_installdirs -p$(psource)  usr/src/modules/$(sname)/debian
	dh_installdirs -p$(pdkms)    usr/src/$(sname)-$(sversion)

	# Copy only the driver source to the proper locations
	cd kernel-module && cp Makefile *.c *.h ../debian/$(psource)/usr/src/modules/$(sname)
	cd kernel-module && cp Makefile *.c *.h ../debian/$(pdkms)/usr/src/$(sname)-$(sversion)

	# Copy the needed debian/ pieces to the proper location
	cp debian/*.modules.in* debian/$(psource)/usr/src/modules/$(sname)/debian
	cp debian/control debian/changelog debian/copyright \
		debian/$(psource)/usr/src/modules/$(sname)/debian/
	install -m 0755 debian/rules.modules debian/$(psource)/usr/src/modules/$(sname)/debian/rules
	cd debian/$(psource)/usr/src && tar c modules | bzip2 -9 > $(sname).tar.bz2 && rm -rf modules

	# Prepare dkms.conf from the dkms.conf.in template
	sed "s/__VERSION__/$(sversion)/g" debian/dkms.conf.in > debian/$(pdkms)/usr/src/$(sname)-$(sversion)/dkms.conf

	# markdown README
	markdown README.md | gzip -9 > debian/README.html.gz
	gzip -9 < README.md > debian/README.md.gz

	dh_auto_install

override_dh_install:
	dh_install
	dh_installdirs -prtpengine-iptables $(XTABLES_DIR)
	install -m 0644 iptables-extension/libxt_RTPENGINE.so debian/rtpengine-iptables/$(XTABLES_DIR)

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbgsym-migration='rtpengine-dbg (<= 6.0.0.0+0~mr6.0.0.0)'

override_dh_dwz:
	# Disable, as dwz cannot cope with some of the plugins generated.

override_dh_installsystemd:
	dh_installsystemd
	dh_installsystemd -prtpengine-recording-daemon --name=rtpengine-recording-nfs-mount

## rtpengine 9.3.2.0+provoice1

=== daemon/Makefile ===
TARGET=		rtpengine

with_iptables_option ?= yes
with_transcoding ?= yes


CFLAGS+=	-g -Wall -Wstrict-prototypes -pthread -fno-strict-aliasing
CFLAGS+=	-std=c99
CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
CFLAGS+=	$(shell pkg-config --cflags zlib)
CFLAGS+=	$(shell pkg-config --cflags openssl)
CFLAGS+=	$(shell pkg-config --cflags libevent_pthreads)
CFLAGS+=	$(shell pkg-config --cflags libpcre)
CFLAGS+=	$(shell pkg-config xmlrpc_client --cflags 2> /dev/null || xmlrpc-c-config client --cflags)
CFLAGS+=	$(shell pkg-config xmlrpc --cflags 2> /dev/null)
CFLAGS+=	$(shell pkg-config xmlrpc_util --cflags 2> /dev/null)
CFLAGS+=	$(shell pkg-config --cflags json-glib-1.0)
CFLAGS+=	$(shell pkg-config --cflags libwebsockets)
ifeq ($(with_iptables_option),yes)
CFLAGS+=	$(shell pkg-config --cflags libiptc)
CFLAGS+=	-DWITH_IPTABLES_OPTION
endif
CFLAGS+=	-I. -I../kernel-module/ -I../lib/ -I../include/
CFLAGS+=	-D_GNU_SOURCE
ifeq ($(with_transcoding),yes)
CFLAGS+=	$(shell pkg-config --cflags libavcodec)
CFLAGS+=	$(shell pkg-config --cflags libavformat)
CFLAGS+=	$(shell pkg-config --cflags libavutil)
CFLAGS+=	$(shell pkg-config --cflags libswresample)
CFLAGS+=	$(shell pkg-config --cflags libavfilter)
CFLAGS+=	$(shell pkg-config --cflags spandsp)
CFLAGS+=	-DWITH_TRANSCODING
CFLAGS+=        $(shell mysql_config --cflags)
else
CFLAGS+=	-DWITHOUT_CODECLIB
endif

CFLAGS+=	-DRE_PLUGIN_DIR="\"/usr/lib/rtpengine\""

### compile time options:
#CFLAGS+=	-DSRTCP_KEY_DERIVATION_RFC_COMPLIANCE
#CFLAGS+=	-DTERMINATE_SDP_AT_BLANK_LINE
#CFLAGS+=	-DSTRICT_SDES_KEY_LIFETIME

LDLIBS=		-lm
LDLIBS+=	$(shell pkg-config --libs glib-2.0)
LDLIBS+=	$(shell pkg-config --libs gthread-2.0)
LDLIBS+=	$(shell pkg-config --libs zlib)
LDLIBS+=	$(shell pkg-config --libs libpcre)
LDLIBS+=	$(shell pkg-config --libs libcrypto)
LDLIBS+=	$(shell pkg-config --libs openssl)
LDLIBS+=	$(shell pkg-config --libs libevent_pthreads)
LDLIBS+=	-lpcap
LDLIBS+=	$(shell pkg-config xmlrpc_client --libs 2> /dev/null || xmlrpc-c-config client --libs)
LDLIBS+=	$(shell pkg-config xmlrpc --libs 2> /dev/null)
LDLIBS+=	$(shell pkg-config xmlrpc_util --libs 2> /dev/null)
LDLIBS+=	-lhiredis
LDLIBS+=	$(shell pkg-config --libs json-glib-1.0)
LDLIBS+=	$(shell pkg-config --libs libwebsockets)
ifeq ($(with_iptables_option),yes)
LDLIBS+=	$(shell pkg-config --libs libiptc)
endif
ifeq ($(with_transcoding),yes)
LDLIBS+=	$(shell pkg-config --libs libavcodec)
LDLIBS+=	$(shell pkg-config --libs libavformat)
LDLIBS+=	$(shell pkg-config --libs libavutil)
LDLIBS+=	$(shell pkg-config --libs libswresample)
LDLIBS+=	$(shell pkg-config --libs libavfilter)
LDLIBS+=	$(shell pkg-config --libs spandsp)
LDLIBS+=        $(shell mysql_config --libs)
endif

ifeq ($(with_transcoding),yes)
include ../lib/g729.Makefile
endif

SRCS=		main.c kernel.c poller.c aux.c control_tcp.c call.c control_udp.c redis.c \
		bencode.c cookie_cache.c udp_listener.c control_ng.strhash.c sdp.strhash.c stun.c rtcp.c \
		crypto.c rtp.c call_interfaces.strhash.c dtls.c log.c cli.c graphite.c ice.c \
		media_socket.c homer.c recording.c statistics.c cdr.c ssrc.c iptables.c tcp_listener.c \
		codec.c load.c dtmf.c timerthread.c media_player.c jitter_buffer.c t38.c websocket.c
LIBSRCS=	loglib.c auxlib.c rtplib.c str.c socket.c streambuf.c ssllib.c dtmflib.c
ifeq ($(with_transcoding),yes)
LIBSRCS+=	codeclib.c resample.c
endif
OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o)

PODS=		rtpengine.pod
MANS=		$(PODS:.pod=.8)

include ../lib/common.Makefile

ifeq ($(with_transcoding),yes)
codec.c:	dtmf_rx_fillin.h
t38.c:		spandsp_logging.h
endif

=== recording-daemon/Makefile ===
TARGET=		rtpengine-recording

CFLAGS+=	-g -Wall -Wstrict-prototypes -pthread -I. -I../lib/ -I../kernel-module/
CFLAGS+=	-std=c99 -fno-strict-aliasing
CFLAGS+=	-D_GNU_SOURCE -D_POSIX_SOURCE -D_POSIX_C_SOURCE
CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
CFLAGS+=	$(shell pkg-config --cflags libavcodec)
CFLAGS+=	$(shell pkg-config --cflags libavformat)
CFLAGS+=	$(shell pkg-config --cflags libavutil)
CFLAGS+=	$(shell pkg-config --cflags libswresample)
CFLAGS+=	$(shell pkg-config --cflags libavfilter)
CFLAGS+=	$(shell mysql_config --cflags)
CFLAGS+=	$(shell pkg-config --cflags openssl)

LDLIBS=		-lm
LDLIBS+=	$(shell pkg-config --libs glib-2.0)
LDLIBS+=	$(shell pkg-config --libs gthread-2.0)
LDLIBS+=	$(shell pkg-config --libs libavcodec)
LDLIBS+=	$(shell pkg-config --libs libavformat)
LDLIBS+=	$(shell pkg-config --libs libavutil)
LDLIBS+=	$(shell pkg-config --libs libswresample)
LDLIBS+=	$(shell pkg-config --libs libavfilter)
LDLIBS+=	$(shell mysql_config --libs)
LDLIBS+=	$(shell pkg-config --libs openssl)

include ../lib/g729.Makefile

SRCS=		epoll.c garbage.c inotify.c main.c metafile.c stream.c recaux.c packet.c \
		decoder.c output.c mix.c db.c log.c forward.c tag.c poller.c
LIBSRCS=	loglib.c auxlib.c rtplib.c codeclib.c resample.c str.c socket.c streambuf.c ssllib.c \
		dtmflib.c
OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o)

PODS=		rtpengine-recording.pod
MANS=		$(PODS:.pod=.8)

include ../lib/common.Makefile

=== t/Makefile ===
TARGET=		all-tests

with_transcoding ?= yes

CFLAGS=		-g -Wall -Wstrict-prototypes -pthread -fno-strict-aliasing
CFLAGS+=	-std=c99
CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
CFLAGS+=	$(shell pkg-config --cflags openssl)
CFLAGS+=	-I. -I../lib/ -I../kernel-module/ -I../include/
CFLAGS+=	-D_GNU_SOURCE
CFLAGS+=	$(shell pkg-config --cflags libpcre)
ifeq ($(with_transcoding),yes)
CFLAGS+=	$(shell pkg-config --cflags libavcodec)
CFLAGS+=	$(shell pkg-config --cflags libavformat)
CFLAGS+=	$(shell pkg-config --cflags libavutil)
CFLAGS+=	$(shell pkg-config --cflags libswresample)
CFLAGS+=	$(shell pkg-config --cflags libavfilter)
CFLAGS+=	$(shell pkg-config --cflags spandsp)
CFLAGS+=	-DWITH_TRANSCODING
CFLAGS+=	$(shell pkg-config --cflags zlib)
CFLAGS+=	$(shell pkg-config --cflags json-glib-1.0)
CFLAGS+=	$(shell pkg-config --cflags libevent_pthreads)
CFLAGS+=	$(shell pkg-config xmlrpc_client --cflags 2> /dev/null || xmlrpc-c-config client --cflags)
CFLAGS+=	$(shell pkg-config xmlrpc --cflags 2> /dev/null)
CFLAGS+=	$(shell pkg-config xmlrpc_util --cflags 2> /dev/null)
ifeq ($(with_amr_tests),yes)
CFLAGS+=	-DWITH_AMR_TESTS
endif
CFLAGS+=	$(shell mysql_config --cflags)
else
CFLAGS+=	-DWITHOUT_CODECLIB
endif

LDLIBS=		-lm
LDLIBS+=	$(shell pkg-config --libs glib-2.0)
LDLIBS+=	$(shell pkg-config --libs gthread-2.0)
LDLIBS+=	$(shell pkg-config --libs libcrypto)
LDLIBS+=	$(shell pkg-config --libs openssl)
LDLIBS+=	$(shell pkg-config --libs libpcre)
ifeq ($(with_transcoding),yes)
LDLIBS+=	$(shell pkg-config --libs libavcodec)
LDLIBS+=	$(shell pkg-config --libs libavformat)
LDLIBS+=	$(shell pkg-config --libs libavutil)
LDLIBS+=	$(shell pkg-config --libs libswresample)
LDLIBS+=	$(shell pkg-config --libs libavfilter)
LDLIBS+=	$(shell pkg-config --libs spandsp)
LDLIBS+=	$(shell pkg-config --libs zlib)
LDLIBS+=	$(shell pkg-config --libs json-glib-1.0)
LDLIBS+=	-lpcap
LDLIBS+=	$(shell pkg-config --libs libevent_pthreads)
LDLIBS+=	$(shell pkg-config xmlrpc_client --libs 2> /dev/null || xmlrpc-c-config client --libs)
LDLIBS+=	$(shell pkg-config xmlrpc --libs 2> /dev/null)
LDLIBS+=	$(shell pkg-config xmlrpc_util --libs 2> /dev/null)
LDLIBS+=	-lhiredis
LDLIBS+=	$(shell mysql_config --libs)
endif

SRCS=		test-bitstr.c aes-crypt.c aead-aes-crypt.c test-const_str_hash.strhash.c
LIBSRCS=	loglib.c auxlib.c str.c rtplib.c
DAEMONSRCS=	crypto.c ssrc.c aux.c rtp.c
HASHSRCS=

ifeq ($(with_transcoding),yes)
SRCS+=		test-transcode.c test-dtmf-detect.c test-payload-tracker.c
SRCS+=		spandsp_recv_fax_pcm.c spandsp_recv_fax_t38.c spandsp_send_fax_pcm.c \
		spandsp_send_fax_t38.c
ifeq ($(with_amr_tests),yes)
SRCS+=		test-amr-decode.c test-amr-encode.c
endif
LIBSRCS+=	codeclib.c resample.c socket.c streambuf.c dtmflib.c
DAEMONSRCS+=	codec.c call.c ice.c kernel.c media_socket.c stun.c bencode.c poller.c \
		dtls.c recording.c statistics.c rtcp.c redis.c iptables.c graphite.c \
		cookie_cache.c udp_listener.c homer.c load.c cdr.c dtmf.c timerthread.c \
		media_player.c jitter_buffer.c t38.c tcp_listener.c
HASHSRCS+=	call_interfaces.c control_ng.c sdp.c
endif

OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o) $(DAEMONSRCS:.c=.o) $(HASHSRCS:.c=.strhash.o)

COMMONOBJS=	str.o auxlib.o rtplib.o loglib.o

include ../lib/common.Makefile

.PHONY:		all-tests unit-tests daemon-tests all-daemon-tests \
	daemon-tests-main daemon-tests-jb daemon-tests-reorder

TESTS=		test-bitstr aes-crypt aead-aes-crypt test-const_str_hash.strhash
ifeq ($(with_transcoding),yes)
TESTS+=		test-transcode test-dtmf-detect test-payload-tracker
ifeq ($(with_amr_tests),yes)
TESTS+=		test-amr-decode test-amr-encode
endif
endif

ADD_CLEAN=	tests-preload.so $(TESTS)

ifeq ($(with_transcoding),yes)
all-tests:	unit-tests daemon-tests
else
all-tests:	unit-tests
endif
	true # override linking recipe from common.Makefile

unit-tests:	$(TESTS)
	for x in $(TESTS); do echo testing: $$x; G_DEBUG=fatal-warnings ./$$x || exit 1; done

daemon-tests:	tests-preload.so
	$(MAKE) -C ../daemon
	$(MAKE) all-daemon-tests

all-daemon-tests: daemon-tests-main daemon-tests-jb daemon-tests-reorder

daemon-tests-main:
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-jb:
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-jb.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-reorder:
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-reorder.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

test-bitstr:	test-bitstr.o

spandsp_send_fax_pcm:	spandsp_send_fax_pcm.o

spandsp_recv_fax_pcm:	spandsp_recv_fax_pcm.o

spandsp_send_fax_t38:	spandsp_send_fax_t38.o

spandsp_recv_fax_t38:	spandsp_recv_fax_t38.o

spandsp_raw_fax_tests: spandsp_send_fax_pcm spandsp_recv_fax_pcm spandsp_send_fax_t38 spandsp_recv_fax_t38

test-amr-decode: test-amr-decode-test.o $(COMMONOBJS) codeclib.o resample.o dtmflib.o

test-amr-encode: test-amr-encode-test.o $(COMMONOBJS) codeclib.o resample.o dtmflib.o

test-dtmf-detect: test-dtmf-detect.o

aes-crypt:	aes-crypt.o $(COMMONOBJS) crypto.o

aead-aes-crypt:	aead-aes-crypt.o $(COMMONOBJS) crypto.o

test-transcode:	test-transcode.o $(COMMONOBJS) codeclib.o resample.o codec.o ssrc.o call.o ice.o aux.o \
	kernel.o media_socket.o stun.o bencode.o socket.o poller.o dtls.o recording.o statistics.o \
	rtcp.o redis.o iptables.o graphite.o call_interfaces.strhash.o sdp.strhash.o rtp.o crypto.o \
	control_ng.strhash.o \
	streambuf.o cookie_cache.o udp_listener.o homer.o load.o cdr.o dtmf.o timerthread.o \
	media_player.o jitter_buffer.o dtmflib.o t38.o tcp_listener.o

test-payload-tracker: test-payload-tracker.o $(COMMONOBJS) ssrc.o aux.o auxlib.o rtp.o crypto.o codeclib.o \
	resample.o dtmflib.o

test-const_str_hash.strhash: test-const_str_hash.strhash.o $(COMMONOBJS)

tests-preload.so:	tests-preload.c
	$(CC) -g -D_GNU_SOURCE -std=c99 -o $@ -Wall -shared -fPIC $< -ldl

codec.c:	dtmf_rx_fillin.h
t38.c:		spandsp_logging.h

=== debian/changelog ===
rtpengine (9.3.2.0+provoice1) focal; urgency=medium

  * Release for ProVoice on Ubuntu 20.04 LTS

 -- Thomas Lobker <thomas@mediaserve.nl>  Tue, 09 Mar 2021 14:54:55 +0000

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Homepage: https://www.sipwise.com/
 Standards-Version: 3.9.8
 Build-Depends:
+ debhelper-compat (= 12),
  default-libmysqlclient-dev,
  gperf,
- iptables-dev (>= 1.4),
  libavcodec-dev (>= 6:10),
  libavfilter-dev (>= 6:10),
  libavformat-dev (>= 6:10),
@@ -35,7 +35,9 @@
  libssl-dev (>= 1.0.1),
  libswresample-dev (>= 6:10),
  libsystemd-dev,
+ libwebsockets-dev,
  libxmlrpc-core-c3-dev (>= 1.16.07),
+ libxtables-dev (>= 1.4) | iptables-dev (>= 1.4),
  markdown,
  zlib1g-dev,
 
@@ -50,18 +52,13 @@
  lsb-base (>= 3.0-6),
  ${misc:Depends},
  ${shlibs:Depends},
-Conflicts:
- mediaproxy-ng-daemon,
- rtpengine-redis1,
-Replaces:
- mediaproxy-ng-daemon,
- rtpengine-redis1,
 Description: proxy for RTP and media streams used in NGCP, userspace part
  This daemon handles the first stages of proxying media streams and talks to
  the kernel part of the proxy for eventual high-performance packet forwarding.
 
 Package: rtpengine-recording-daemon
 Architecture: any
+Build-Profiles: <!pkg.rtpengine.no-transcoding>
 Recommends:
  rtpengine-utils,
 Suggests:
@@ -79,10 +76,6 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
-Conflicts:
- mediaproxy-ng-iptables,
-Replaces:
- mediaproxy-ng-iptables,
 Description: IPtables extension module for the kernel-space NGCP media proxy
  Provides the IPtables extension needed to configure the mediaproxy rule.
 
@@ -95,10 +88,6 @@
  rtpengine-recording-daemon (>= ${source:Version}),
  rtpengine-utils (>= ${source:Version}),
  ${misc:Depends},
-Conflicts:
- mediaproxy-ng,
-Replaces:
- mediaproxy-ng,
 Description: NGCP RTP/media proxy - meta package
  This is a meta package for easy installation of all four parts of the NGCP
  media proxy. It will install the user-space daemon, the kernel-space IPtables
@@ -108,12 +97,9 @@
 Architecture: all
 Section: kernel
 Depends:
+ debhelper-compat (= 12),
  module-assistant,
  ${misc:Depends},
-Conflicts:
- mediaproxy-ng-kernel-source,
-Replaces:
- mediaproxy-ng-kernel-source,
 Description: IPtables kernel module for the NGCP media proxy - source
  Provides the kernel-space part of the NGCP media proxy for high-
  performance packet forwarding.
@@ -129,10 +115,6 @@
  dkms (>= 1.95),
  lsb-release,
  ${misc:Depends},
-Conflicts:
- mediaproxy-ng-kernel-dkms,
-Replaces:
- mediaproxy-ng-kernel-dkms,
 Description: IPtables kernel module for the NGCP media proxy - DKMS
  Provides the kernel-space part of the NGCP media proxy for high-
  performance packet forwarding.

=== debian/rules ===
--- 
+++ 
@@ -20,6 +20,10 @@
 ## end of kernel package specific stuff
 
 XTABLES_DIR:=$(shell pkg-config xtables --variable=xtlibdir || echo /lib/xtables)
+
+ifneq (,$(filter $(DEB_BUILD_PROFILES),pkg.rtpengine.no-transcoding))
+export with_transcoding = no
+endif
 
 %:
 	dh $@

## rtpengine 10.3.0.0+provoice1

=== daemon/Makefile ===
--- 
+++ 
@@ -4,7 +4,8 @@
 with_transcoding ?= yes
 
 
-CFLAGS+=	-g -Wall -Wstrict-prototypes -pthread -fno-strict-aliasing
+CFLAGS?=	-g -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes
+CFLAGS+=	-pthread -fno-strict-aliasing
 CFLAGS+=	-std=c99
 CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
 CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
@@ -75,11 +76,14 @@
 include ../lib/g729.Makefile
 endif
 
+include ../lib/mqtt.Makefile
+
 SRCS=		main.c kernel.c poller.c aux.c control_tcp.c call.c control_udp.c redis.c \
 		bencode.c cookie_cache.c udp_listener.c control_ng.strhash.c sdp.strhash.c stun.c rtcp.c \
 		crypto.c rtp.c call_interfaces.strhash.c dtls.c log.c cli.c graphite.c ice.c \
 		media_socket.c homer.c recording.c statistics.c cdr.c ssrc.c iptables.c tcp_listener.c \
-		codec.c load.c dtmf.c timerthread.c media_player.c jitter_buffer.c t38.c websocket.c
+		codec.c load.c dtmf.c timerthread.c media_player.c jitter_buffer.c t38.c websocket.c \
+		mqtt.c janus.strhash.c
 LIBSRCS=	loglib.c auxlib.c rtplib.c str.c socket.c streambuf.c ssllib.c dtmflib.c
 ifeq ($(with_transcoding),yes)
 LIBSRCS+=	codeclib.c resample.c
@@ -90,8 +94,3 @@
 MANS=		$(PODS:.pod=.8)
 
 include ../lib/common.Makefile
-
-ifeq ($(with_transcoding),yes)
-codec.c:	dtmf_rx_fillin.h
-t38.c:		spandsp_logging.h
-endif

=== t/Makefile ===
--- 
+++ 
@@ -2,7 +2,9 @@
 
 with_transcoding ?= yes
 
-CFLAGS=		-g -Wall -Wstrict-prototypes -pthread -fno-strict-aliasing
+CFLAGS?=	-g -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes
+PRELOAD_CFLAGS := $(CFLAGS)
+CFLAGS+=	-pthread -fno-strict-aliasing
 CFLAGS+=	-std=c99
 CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
 CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
@@ -20,6 +22,7 @@
 CFLAGS+=	-DWITH_TRANSCODING
 CFLAGS+=	$(shell pkg-config --cflags zlib)
 CFLAGS+=	$(shell pkg-config --cflags json-glib-1.0)
+CFLAGS+=	$(shell pkg-config --cflags libwebsockets)
 CFLAGS+=	$(shell pkg-config --cflags libevent_pthreads)
 CFLAGS+=	$(shell pkg-config xmlrpc_client --cflags 2> /dev/null || xmlrpc-c-config client --cflags)
 CFLAGS+=	$(shell pkg-config xmlrpc --cflags 2> /dev/null)
@@ -47,6 +50,7 @@
 LDLIBS+=	$(shell pkg-config --libs spandsp)
 LDLIBS+=	$(shell pkg-config --libs zlib)
 LDLIBS+=	$(shell pkg-config --libs json-glib-1.0)
+LDLIBS+=	$(shell pkg-config --libs libwebsockets)
 LDLIBS+=	-lpcap
 LDLIBS+=	$(shell pkg-config --libs libevent_pthreads)
 LDLIBS+=	$(shell pkg-config xmlrpc_client --libs 2> /dev/null || xmlrpc-c-config client --libs)
@@ -57,12 +61,12 @@
 endif
 
 SRCS=		test-bitstr.c aes-crypt.c aead-aes-crypt.c test-const_str_hash.strhash.c
-LIBSRCS=	loglib.c auxlib.c str.c rtplib.c
+LIBSRCS=	loglib.c auxlib.c str.c rtplib.c ssllib.c
 DAEMONSRCS=	crypto.c ssrc.c aux.c rtp.c
 HASHSRCS=
 
 ifeq ($(with_transcoding),yes)
-SRCS+=		test-transcode.c test-dtmf-detect.c test-payload-tracker.c
+SRCS+=		test-transcode.c test-dtmf-detect.c test-payload-tracker.c test-resample.c test-stats.c
 SRCS+=		spandsp_recv_fax_pcm.c spandsp_recv_fax_t38.c spandsp_send_fax_pcm.c \
 		spandsp_send_fax_t38.c
 ifeq ($(with_amr_tests),yes)
@@ -72,22 +76,23 @@
 DAEMONSRCS+=	codec.c call.c ice.c kernel.c media_socket.c stun.c bencode.c poller.c \
 		dtls.c recording.c statistics.c rtcp.c redis.c iptables.c graphite.c \
 		cookie_cache.c udp_listener.c homer.c load.c cdr.c dtmf.c timerthread.c \
-		media_player.c jitter_buffer.c t38.c tcp_listener.c
-HASHSRCS+=	call_interfaces.c control_ng.c sdp.c
+		media_player.c jitter_buffer.c t38.c tcp_listener.c mqtt.c websocket.c cli.c
+HASHSRCS+=	call_interfaces.c control_ng.c sdp.c janus.c
 endif
 
 OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o) $(DAEMONSRCS:.c=.o) $(HASHSRCS:.c=.strhash.o)
 
-COMMONOBJS=	str.o auxlib.o rtplib.o loglib.o
+COMMONOBJS=	str.o auxlib.o rtplib.o loglib.o ssllib.o
 
 include ../lib/common.Makefile
 
-.PHONY:		all-tests unit-tests daemon-tests all-daemon-tests \
-	daemon-tests-main daemon-tests-jb daemon-tests-reorder
+.PHONY:		all-tests unit-tests daemon-tests daemon-tests \
+	daemon-tests-main daemon-tests-jb daemon-tests-dtx daemon-tests-dtx-cn daemon-tests-pubsub \
+	daemon-tests-intfs daemon-tests-stats
 
 TESTS=		test-bitstr aes-crypt aead-aes-crypt test-const_str_hash.strhash
 ifeq ($(with_transcoding),yes)
-TESTS+=		test-transcode test-dtmf-detect test-payload-tracker
+TESTS+=		test-transcode test-dtmf-detect test-payload-tracker test-resample test-stats
 ifeq ($(with_amr_tests),yes)
 TESTS+=		test-amr-decode test-amr-encode
 endif
@@ -105,13 +110,13 @@
 unit-tests:	$(TESTS)
 	for x in $(TESTS); do echo testing: $$x; G_DEBUG=fatal-warnings ./$$x || exit 1; done
 
-daemon-tests:	tests-preload.so
+daemon-tests: daemon-tests-main daemon-tests-jb daemon-tests-pubsub daemon-tests-websocket \
+	daemon-tests-intfs daemon-tests-stats
+
+daemon-test-deps:	tests-preload.so
 	$(MAKE) -C ../daemon
-	$(MAKE) all-daemon-tests
-
-all-daemon-tests: daemon-tests-main daemon-tests-jb daemon-tests-reorder
-
-daemon-tests-main:
+
+daemon-tests-main:	daemon-test-deps
 	rm -rf fake-$@-sockets
 	mkdir fake-$@-sockets
 	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
@@ -119,7 +124,7 @@
 	test "$$(ls fake-$@-sockets)" = ""
 	rmdir fake-$@-sockets
 
-daemon-tests-jb:
+daemon-tests-jb:	daemon-test-deps
 	rm -rf fake-$@-sockets
 	mkdir fake-$@-sockets
 	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
@@ -127,11 +132,51 @@
 	test "$$(ls fake-$@-sockets)" = ""
 	rmdir fake-$@-sockets
 
-daemon-tests-reorder:
-	rm -rf fake-$@-sockets
-	mkdir fake-$@-sockets
-	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
-		   perl -I../perl auto-daemon-tests-reorder.pl
+daemon-tests-dtx:	daemon-test-deps
+	rm -rf fake-$@-sockets
+	mkdir fake-$@-sockets
+	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
+		   perl -I../perl auto-daemon-tests-dtx.pl
+	test "$$(ls fake-$@-sockets)" = ""
+	rmdir fake-$@-sockets
+
+daemon-tests-dtx-cn:	daemon-test-deps
+	rm -rf fake-$@-sockets
+	mkdir fake-$@-sockets
+	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
+		   perl -I../perl auto-daemon-tests-dtx-cn.pl
+	test "$$(ls fake-$@-sockets)" = ""
+	rmdir fake-$@-sockets
+
+daemon-tests-pubsub:	daemon-test-deps
+	rm -rf fake-$@-sockets
+	mkdir fake-$@-sockets
+	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
+		   perl -I../perl auto-daemon-tests-pubsub.pl
+	test "$$(ls fake-$@-sockets)" = ""
+	rmdir fake-$@-sockets
+
+daemon-tests-stats:	daemon-test-deps
+	rm -rf fake-$@-sockets
+	mkdir fake-$@-sockets
+	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
+		   perl -I../perl auto-daemon-tests-stats.pl
+	test "$$(ls fake-$@-sockets)" = ""
+	rmdir fake-$@-sockets
+
+daemon-tests-websocket:	daemon-test-deps
+	rm -rf fake-$@-sockets
+	mkdir fake-$@-sockets
+	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
+		   python3 auto-daemon-tests-websocket.py
+	test "$$(ls fake-$@-sockets)" = ""
+	rmdir fake-$@-sockets
+
+daemon-tests-intfs:	daemon-test-deps
+	rm -rf fake-$@-sockets
+	mkdir fake-$@-sockets
+	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
+		   perl -I../perl auto-daemon-tests-intfs.pl
 	test "$$(ls fake-$@-sockets)" = ""
 	rmdir fake-$@-sockets
 
@@ -156,21 +201,39 @@
 aes-crypt:	aes-crypt.o $(COMMONOBJS) crypto.o
 
 aead-aes-crypt:	aead-aes-crypt.o $(COMMONOBJS) crypto.o
+
+test-stats:	test-stats.o $(COMMONOBJS) codeclib.o resample.o codec.o ssrc.o call.o ice.o aux.o \
+	kernel.o media_socket.o stun.o bencode.o socket.o poller.o dtls.o recording.o statistics.o \
+	rtcp.o redis.o iptables.o graphite.o call_interfaces.strhash.o sdp.strhash.o rtp.o crypto.o \
+	control_ng.strhash.o graphite.o \
+	streambuf.o cookie_cache.o udp_listener.o homer.o load.o cdr.o dtmf.o timerthread.o \
+	media_player.o jitter_buffer.o dtmflib.o t38.o tcp_listener.o mqtt.o janus.strhash.o \
+	websocket.o cli.o
 
 test-transcode:	test-transcode.o $(COMMONOBJS) codeclib.o resample.o codec.o ssrc.o call.o ice.o aux.o \
 	kernel.o media_socket.o stun.o bencode.o socket.o poller.o dtls.o recording.o statistics.o \
 	rtcp.o redis.o iptables.o graphite.o call_interfaces.strhash.o sdp.strhash.o rtp.o crypto.o \
 	control_ng.strhash.o \
 	streambuf.o cookie_cache.o udp_listener.o homer.o load.o cdr.o dtmf.o timerthread.o \
-	media_player.o jitter_buffer.o dtmflib.o t38.o tcp_listener.o
+	media_player.o jitter_buffer.o dtmflib.o t38.o tcp_listener.o mqtt.o janus.strhash.o websocket.o \
+	cli.o
+
+test-resample:	test-resample.o $(COMMONOBJS) codeclib.o resample.o dtmflib.o
 
 test-payload-tracker: test-payload-tracker.o $(COMMONOBJS) ssrc.o aux.o auxlib.o rtp.o crypto.o codeclib.o \
 	resample.o dtmflib.o
 
+test-kernel-module: test-kernel-module.o $(COMMONOBJS) kernel.o
+
 test-const_str_hash.strhash: test-const_str_hash.strhash.o $(COMMONOBJS)
 
+PRELOAD_CFLAGS += -D_GNU_SOURCE -std=c99
+PRELOAD_LIBS += -ldl
+
 tests-preload.so:	tests-preload.c
-	$(CC) -g -D_GNU_SOURCE -std=c99 -o $@ -Wall -shared -fPIC $< -ldl
-
-codec.c:	dtmf_rx_fillin.h
-t38.c:		spandsp_logging.h
+	$(CC) $(PRELOAD_CFLAGS) -o $@ -shared -fPIC $< $(LDFLAGS) $(PRELOAD_LIBS)
+
+spandsp_send_fax_pcm.c:	spandsp_logging.h
+spandsp_send_fax_t38.c:	spandsp_logging.h
+spandsp_recv_fax_t38.c:	spandsp_logging.h
+spandsp_recv_fax_pcm.c:	spandsp_logging.h

=== debian/changelog ===
rtpengine (10.3.0.0+provoice1) focal; urgency=medium

  * Release for ProVoice on Ubuntu 20.04 LTS

 -- Thomas Lobker <thomas@mediaserve.nl>  Wed, 08 Dec 2021 10:17:38 +0000

=== debian/control ===
--- 
+++ 
@@ -27,6 +27,7 @@
  libio-socket-ip-perl,
  libiptc-dev,
  libjson-glib-dev,
+ libmosquitto-dev,
  libnet-interface-perl,
  libpcap0.8-dev,
  libpcre3-dev,
@@ -39,6 +40,8 @@
  libxmlrpc-core-c3-dev (>= 1.16.07),
  libxtables-dev (>= 1.4) | iptables-dev (>= 1.4),
  markdown,
+ python3,
+ python3-websockets,
  zlib1g-dev,
 
 Package: rtpengine-daemon
@@ -49,6 +52,7 @@
 Suggests:
  system-tools,
 Depends:
+ iptables,
  lsb-base (>= 3.0-6),
  ${misc:Depends},
  ${shlibs:Depends},

=== debian/rules ===
--- 
+++ 
@@ -15,14 +15,18 @@
 sname:=rtpengine
 # Source version
 sversion:=$(DEB_VERSION_UPSTREAM)
-
-PACKAGE=rtpengine-kernel
 ## end of kernel package specific stuff
 
 XTABLES_DIR:=$(shell pkg-config xtables --variable=xtlibdir || echo /lib/xtables)
 
 ifneq (,$(filter $(DEB_BUILD_PROFILES),pkg.rtpengine.no-transcoding))
 export with_transcoding = no
+endif
+ifneq (,$(filter $(DEB_BUILD_PROFILES),pkg.rtpengine.asan))
+export DO_ASAN_FLAGS = 1
+# this prevents dh from setting default (including -O2) which we don't want
+export DEB_CFLAGS_MAINT_SET =
+export DEB_LDFLAGS_MAINT_SET =
 endif
 
 %:
@@ -58,10 +62,6 @@
 	dh_installdirs -prtpengine-iptables $(XTABLES_DIR)
 	install -m 0644 iptables-extension/libxt_RTPENGINE.so debian/rtpengine-iptables/$(XTABLES_DIR)
 
-.PHONY: override_dh_strip
-override_dh_strip:
-	dh_strip --dbgsym-migration='rtpengine-dbg (<= 6.0.0.0+0~mr6.0.0.0)'
-
 override_dh_dwz:
 	# Disable, as dwz cannot cope with some of the plugins generated.
